public class Matrix {
    private int line; // Lignes
    private int col; // Colonnes
    private double[][] data;

    public int getLine() {
        return line;
    }

    public int getCol() {
        return col;
    }

    public double getData(int line, int col) {
        return data[line][col];
    }

    public double[][] getDatas() {
        return data;
    }

    public void setData(int line, int col, double d) {
        this.data[line][col] = d;
    }

    public Matrix(int line, int col) {
        this.line = line;
        this.col = col;
        this.data = new double[line][col];
    }

    public void matrixFill(int line, int col, double[][] tab) throws IndexOutOfBoundsException {
        for (int i = 0; i < line; i++) {
            for (int j = 0; j < col; j++) {
                if (i < tab.length && j < tab[i].length)
                    this.data[i][j] = tab[i][j];
            }
        }
    }

    public void matrixRealloc(int line, int col) {
        double[][] tmp = this.data;
        this.line = line;
        this.col = col;
        this.data = new double[line][col];
        matrixFill(line, col, tmp);
    }

    public void matrixPrint(String s) {
        System.out.println();
        System.out.println(s + ": ");
        for (int i = 0; i < line; i++) {
            for (int j = 0; j < col; j++) {
                System.out.format("%10.2f", this.data[i][j]);
            }
            System.out.println();
        }
    }

    public void printTabAux(String s, int nbX, int nbZ, int nbAux) {
        System.out.println("---------------------------");
        System.out.println(s);
        System.out.println("---------------------------");
        System.out.print("COLS:              ");
        for (int i = 0; i < nbX; i++) {
            System.out.format("X[%d]      ", i);
        }

        for (int i = 0; i < nbZ; i++) {
            if (i < 10)
                System.out.format("Z[%d]      ", i);
            else
                System.out.format("Z[%d]     ", i);
        }

        System.out.format("S[%d]     ", this.col / 2);

        for (int i = 0; i < nbAux; i++) {
            if (i < 10)
                System.out.format("A[%d]      ", i);
            else
                System.out.format("A[%d]     ", i);
        }
        System.out.println();

        for (int i = 0; i < this.line; i++) {
            if (i < this.line - 2)
                if (i < 10)
                    System.out.print("AUX_" + i + "     |   ");
                else
                    System.out.print("AUX_" + i + "    |   ");
            else if (i == this.line - 2)
                System.out.print("OBJ. Init |   ");
            else System.out.print("OBJ.      |   ");
            for (int j = 0; j < this.col; j++) {
                System.out.format("%10.3f", this.data[i][j]);
            }
            System.out.println();
        }
    }
}
